;
; lzo.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

		lda #<buffer
		sta p2
		lda #>buffer
		sta p2+1
blockloop
		ldx #8
-		jsr kernal.chrin	; sizes
		dex
		bne -
		lda kernal.status
		beq ok
ki
		ldx #OUTPUT_LFN
		stx myout
		jsr kernal.chkout

		lda p2+1
		sec
		sbc #>buffer+size(buffer)/2
		ldx #>buffer+size(buffer)/2
		bge +
		adc #>size(buffer)/2
		ldx #>buffer
+		stx p2+1
		tay

		ldx p2
		lda #0
		sta p2
		lda #p2
		jmp write

flags		.dword 0
ok
		lda #1
		bit flags
		bne +
		bit flags+1
		beq ++
+
		ldx #4
-		jsr kernal.chrin	; checksum
		dex
		bne -
+
		lda #2
		bit flags
		bne +
		bit flags+1
		beq ++
+
		ldx #4
-		jsr kernal.chrin	; checksum
		dex
		bne -
+

		ldy #0
                sty t+1

		jsr kernal.chrin
                cmp #18
		blt in
                sbc #17
                cmp #4
                blt match_next
                tax
-		jsr kernal.chrin
		sta (p2),y
		inc p2
                bne +
		jsr incp2
+               dex
                bne -
                geq first_literal_run

lzoloop		lda kernal.status
		bne ki
		jsr kernal.chrin
in              cmp #16
		bge match
                adc #3
                cmp #3
                bne n0
		ldx #15+3
                jsr big
n0              tax
-		jsr kernal.chrin
		sta (p2),y
		inc p2
                bne +
		jsr incp2
+               txa
                bne +
                dec t+1
+               dex
                bne -
                lda t+1
                bne -

first_literal_run
		jsr kernal.chrin
                cmp #16
                bge match
		sta oldt
		lsr a			; 0000aass xxxxxxxx -> 10xx xxxxxxaa   3 bytes
		lsr a
                sta t2
                lda #8 >> 2
                sta t2+1
		jsr kernal.chrin
		asl a
                rol t2+1
		asl a
                rol t2+1
                ora t2
                sta t2
                ldx #3
                gcc copy_match

match
                cmp #64
                blt nm2
		sta oldt		; lllaaass xxxxxxxx -> xxx xxxxxaaa   3-8 bytes
		lsr a
		lsr a
                tax
                and #7
                sta t2
                lda #0
                sta t2+1
		jsr kernal.chrin
		asl a
                rol t2+1
		asl a
                rol t2+1
		asl a
                rol t2+1
                ora t2
                sta t2
		txa
		lsr a
		lsr a
		lsr a
                tax
                inx
                clc
                gcc copy_match

nm2             cmp #32
                blt nm3
                and #31
                bne n02
		ldx #31+2
                jsr big
                .byte $2c
n02             adc #2-1
                tax

		jsr kernal.chrin
                sta oldt
                sta t2
		jsr kernal.chrin
		lsr a
                ror t2
		lsr a
                ror t2
                sta t2+1
                clc
                gcc copy_match

nm3             cmp #16
                blt nm4
		and #15
		cmp #8
		php
                and #7
                bne +
		ldx #7+2
                jsr big
		jmp ++
+               clc
                adc #2
+		tax

		jsr kernal.chrin
		sta oldt
                sta t2
		jsr kernal.chrin
		plp
		ror a
                ror t2
		lsr a
                ror t2
		clc
		adc #$40
		sta t2+1
		eor #$40
		ora t2
		beq blockloop		; eof
		sec
		gcs copy_match
nm4
		sta oldt		; 0000aass xxxxxxxx -> xx xxxxxxaa   2 bytes
		lsr a
		lsr a
                sta t2
                lda #0
                sta t2+1
		jsr kernal.chrin
		asl a
                rol t2+1
		asl a
		rol t2+1
                ora t2
                sta t2
                ldx #2

copy_match	lda p2
                sbc t2
		sta p3
		lda p2+1
		sbc t2+1
		blt +
		cmp #>buffer
		bge ++
+		adc #>size(buffer)
+		sta p3+1

-		lda (p3),y
		sta (p2),y
		inc p2
		bne +
		jsr incp2
+		inc p3
		bne +
		jsr incp3
+
		txa
		bne +
                dec t+1
+               dex
                bne -
		lda t+1
                bne -

match_done	lda oldt
                and #3
		beq lzoloop
match_next      tax
-		jsr kernal.chrin
		sta (p2),y
		inc p2
                bne +
		jsr incp2
+               dex
                bne -
		lda kernal.status
		bne ki
		jsr kernal.chrin
                jmp match

-		txa
		beq +
                inc t+1
+		dex
big		jsr kernal.chrin
		beq -

		stx (+)+1
+               adc #0
                bcc +
                inc t+1
+		rts

incp3		inc p3+1
		lda p3+1
		eor #>buffer+size(buffer)
		bne +
		lda #>buffer
		sta p3+1
+		rts

incp2		inc p2+1
		lda p2+1
		eor #>buffer+size(buffer)/2
		bne +
		lda #>buffer
		jsr flush
		lda #>buffer+size(buffer)/2
		sta p2+1
		rts
+
		eor #(>buffer+size(buffer))^(>buffer+size(buffer)/2)
		bne +
		lda #>buffer+size(buffer)/2
		jsr flush
		lda #>buffer
		sta p2+1
+		rts

flush		sta p2+1
		txa
		pha
		tya
		pha
		ldx #OUTPUT_LFN
		stx myout
		jsr kernal.chkout

		ldx #<size(buffer)/2
		ldy #>size(buffer)/2
		lda #p2
		jsr write

		ldx #INPUT_LFN
		jsr kernal.chkin
		pla
		tay
		pla
		tax
		rts
