;
; utf8.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

fromascii	.proc
		cmp #65
		blt _same
		cmp #91
		blt _capital
		beq _same
		cmp #93
		beq _same
		cmp #95
		beq _underscore
		cmp #97			;a-z
		blt _ill
		cmp #123
		bge _ill
		eor #$20^95^$a4
_underscore	eor #95^$a4^$80
_capital	eor #$80
_same		rts

_ill		lda #32
		rts
		.pend

topetscii	.proc
		jsr parse.get
		cmp #%11000000		; utf8?
		blt fromascii
		jsr parse
		lda parse.utf+1
		bne _nascii
		lda parse.utf
		bpl fromascii
		lsr a			; fall through
_nascii
		cmp #>$e100
		bne _npetscii
		lda parse.utf
		rts
_npetscii
		stx _xt
		ldx #size(chars)-1
-		lda low,x
		cmp parse.utf
		bne +
		lda high,x
		cmp parse.utf+1
		beq _found
+		dex
		bpl -
		lda #32
		gne _exit
_found
		lda chars,x
_xt		= *+1
_exit		ldx #0
		rts

		.section data
_list		= [$2215, $2f, $a3, $5c, $2191, $5e, $2190, $5f, $a0, $a0, $258c, $a1, $2584, $a2, $2594, $a3, $258f, $a5, $2592, $a6, $2595, $a7, $251c, $ab, $2597, $ac, $2514, $ad, $2510, $ae, $2582, $af, $250c, $b0, $2534, $b1, $252c, $b2, $2524, $b3, $258e, $b4, $258d, $b5, $2583, $b9, $2713, $ba, $2596, $bb, $259d, $bc, $2518, $bd, $2598, $be, $259a, $bf, $2500, $c0, $253c, $db, $2502, $dd, $3c0, $ff]
low		.byte <_list[::2]
high		.byte >_list[::2]
chars		.byte _list[1::2]

;_list2		= [$1fb8f, $a8, $1fb99, $a9, $1fb87, $aa, $1fb88, $b6, $1fb82, $b7, $1fb83, $b8, $1fb8c, $dc, $1fb98, $df]
;low2		.byte <_list2[::2]
;chars2		.byte _list2[1::2]
		.send data
		.pend

parse		.proc
		cmp #%11100000		;2 byte
                bcs +
                and #$1f
		sta utf+1
		jsr get
		asl a
		bcc _ill
		asl a
		bcs _ill
		lsr utf+1
		ror a
		lsr utf+1
		ror a
		sta utf
		rts

+               cmp #%11110000
		bcs +
		sta utf+1
		jsr get
		sta utf
		jsr get
		asl a
		bcc _ill
		asl a
		bcs _ill
		asl a
		rol utf
		bcc _ill
		asl a
		rol utf
		bcs _ill
-		asl a
		rol utf
		rol utf+1
		bcs -
		rts

+               cmp #%11111000
		bcc _a1
                cmp #%11111100
		bcc _a2
		jsr get
_a2		jsr get
_a1		jsr get
		jsr get
		jsr get
_ill		lda #32
		sta utf
		lda #0
		sta utf+1
		rts

		.weak
get		jmp $ffff
get.vector	= get+1
		.endweak

		.section bss
utf		.word ?
		.send bss

		.pend
