;
; more.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;; more [file]
;;
;;   Prints file content one screen at a time. Press any key to continue
;;   or stop to exit.
;;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

WILDEXP		= false

INPUT_LFN	= 1

lines		= $fd

banner		= "more 0.2 by soci/singular"

		.include "lib.asm"

		.section code
start2		.proc
		ldx #<arglist
		ldy #>arglist
		jsr parseargs

		lda arglist
		ldx #<(arglist+1)
		ldy #>(arglist+1)
		jsr kernal.setnam
		lda #INPUT_LFN
		ldx mydrive
		ldy #0
		jsr kernal.setlfs
		jsr kernal.open
		bcs err2
		ldx #INPUT_LFN
		jsr kernal.chkin
		bcs err
		ldx #STDOUT_LFN
		jsr kernal.chkout
		bcs err

loop		lda #0
		sta lines
		ldx #0
-		jsr kernal.chrin
		ldy kernal.status
		bne en
		ldy #1
		sty kernal.quote
		jsr kernal.chrout
		asl a
		cmp #26
		beq lf
		inx
		cpx #40
		blt -
lf		ldx #0
		inc lines
		lda lines
		cmp #24
		bne -
-		ldy kernal.stop
		iny
		beq -
		cpy #$80
		beq fin
		gne loop

en		cpy #$40
		bne fin
		ldy #1
		sty kernal.quote
		jsr kernal.chrout
fin
		lsr kernal.quote
		jsr kernal.clrchn
err		lda #INPUT_LFN
		jsr kernal.close
err2		jmp exit
		.pend
		.send code
